﻿using System.Configuration;

namespace Saml2Code
{
    public class ConfigurationSettingsHelper
    {
        public static string GetCriticalConfigSetting(string key)
        {
            string value;
            if ((value = ConfigurationManager.AppSettings[key]) == null)
            {
                //LoggingAPI.InsertLog((int)ComponentCodeLogging.IDPCore, Source.GENERAL, LoggingType.Fatal, 
                //    "FATAL: Application Terminated! Critical configuration key '" + key + "' was not found.");
                System.Environment.Exit(-1);
            }
            return value;
        }

        public static bool GetCriticalConfigBoolSetting(string key)
        {
            bool result, success = bool.TryParse(GetCriticalConfigSetting(key), out result);
            if (!success)
            {
                //LoggingAPI.InsertLog((int)ComponentCodeLogging.IDPCore, Source.GENERAL, LoggingType.Fatal,
                //    "FATAL: Application Terminated! Critical configuration key '" + key + "' was not found.");
                System.Environment.Exit(-1);
            }
            return result;
        }

        public static int GetCriticalConfigIntSetting(string key)
        {
            int result;
            bool success = int.TryParse(GetCriticalConfigSetting(key), out result);
            if (!success)
            {
                //LoggingAPI.InsertLog((int)ComponentCodeLogging.IDPCore, Source.GENERAL, LoggingType.Fatal,
                //    "FATAL: Application Terminated! Critical configuration key '" + key + "' was not found.");
                System.Environment.Exit(-1);
            }
            return result;
        }

        public static bool? GetConfigBoolSetting(string key)
        {
            bool result, success = bool.TryParse(GetConfigurationSetting(key), out result);
            if (!success)
                return null;
            return result;
        }

        public static int? GetConfigIntSetting(string key)
        {
            int result;
            bool success = int.TryParse(GetConfigurationSetting(key), out result);
            if (!success)
                return null;
            return result;
        }

        /// <summary>
        /// Gets the configuration setting.
        /// </summary>
        /// <param name="configurationSettingKey">The configuration setting key.</param>
        /// <returns></returns>
        public static string GetConfigurationSetting(string configurationSettingKey)
        {
            string configurationSettingValue = string.Empty;

            if (System.Configuration.ConfigurationManager.AppSettings[configurationSettingKey] != null)
                configurationSettingValue = System.Configuration.ConfigurationManager.AppSettings[configurationSettingKey];
            //else
            //    LoggingAPI.InsertLog((int)ComponentCodeLogging.IDPCore,Source.GENERAL,LoggingType.Information,"NULL VALUE FOR KEY - " + configurationSettingKey);
            return configurationSettingValue;
        }

    }
}
