﻿using System;
using System.Text;
using System.Xml;
using System.Security.Cryptography;

namespace Saml2Code
{
    public partial class _Default : System.Web.UI.Page
    {
        protected string sendTo;

        protected string method;

        protected XmlDocument xml;

        protected string base64String;

        Boolean afirma, clavePermanente, pin24h, eidas, relaystate, auth, idpMovil;

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                afirma = false;
                clavePermanente = false;
                pin24h = false;
                eidas = false;
                relaystate = false;
                auth = false;
                idpMovil = false;

                PopulateLoA();

                sendTo = Conf.get_url_eidas();

                prepare_Request();
            }
            catch (Exception ex)
            {
                //TODO: Failed to get prepare the request
            }
        }

        private void prepare_Request()
        {
            string samlRequestField = ConfigurationSettingsHelper.GetCriticalConfigSetting("samlRequestField"),
            relayStateField = ConfigurationSettingsHelper.GetCriticalConfigSetting("relayStateField");
            method = Conf.get_url_redirect_method();
            base64String = GetSAMLRequestB64();
        }

        private string GetSAMLRequestB64()
        {
            // Default request
            string loavalue = null;

            loavalue = DropDownListLoA.SelectedValue;

            xml = XMLData.Saml2RequestDefault(Conf.get_saml2_request_attributes(), sendTo, afirma, clavePermanente,
                pin24h, eidas, idpMovil, auth, relaystate, loavalue);

            // Sign the request
            XmlDocument xmlsigned = Sign.SignXmlFile((RSACryptoServiceProvider)Utils.CreateKey(2), Utils.CreateCert(2),
                xml, null);

            Session["SAMLRequest"] = xmlsigned;

            return Convert.ToBase64String(Encoding.UTF8.GetBytes(xmlsigned.OuterXml));
        }

        protected void checkMethod(object sender, EventArgs e)
        {
            auth = check.Items[0].Selected;
            relaystate = check.Items[1].Selected;

            prepare_Request();
        }

        protected void checkMethod_2(object sender, EventArgs e)
        {

            afirma = check2.Items[0].Selected;
            clavePermanente = check2.Items[1].Selected;
            pin24h = check2.Items[2].Selected;
            eidas = check2.Items[3].Selected;
            idpMovil = check2.Items[4].Selected;

            prepare_Request();
        }

        private void PopulateLoA()
        {
            for (int i = 0; i < Conf.get_loa_forms().Length; i++)
            {
                if(DropDownListLoA.Items.FindByValue(Conf.get_loa_forms()[i]) == null)
                    DropDownListLoA.Items.Add(Conf.get_loa_forms()[i]);
            }
        }
    }
}
