﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using Saml2Code;
using System.Xml;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
using System.Text;

namespace eu.stork.sp
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected string sendTo;

        protected string method;

        protected XmlDocument xml;

        protected string base64String;

        protected void do_logout(object sender, EventArgs e)
        {
            try
            {
                string samlRequestField = ConfigurationSettingsHelper.GetCriticalConfigSetting("SAMLRequestLogoutField"),
                relayStateField = ConfigurationSettingsHelper.GetCriticalConfigSetting("relayStateField"),
                method = Conf.get_url_redirect_method();
                string postForm = string.Empty;

                base64String = GetSAMLRequestB64();

                postForm = PostMethods.PreparePOSTForm(
                    samlRequestField, relayStateField,
                    base64String, "State information to be persisted across",
                    method);

                this.Page.Controls.Add(new LiteralControl(postForm));
            }
            catch (Exception ex)
            {
                //TODO
            }
        }

        private String GetSAMLRequestB64()
        {
            XmlDocument doc = XMLData.saml2LogOut();

            RSA key = (RSA)Utils.CreateKey(2);
            X509Certificate2 cert = Utils.CreateCert(2);

            XmlDocument docSigned = Sign.SignXmlFile(key, cert, doc, null);

            return Convert.ToBase64String(Encoding.UTF8.GetBytes(docSigned.OuterXml));
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            XmlDocument xmlResponse = (XmlDocument)Session["SAMLResponse"];

            if (xmlResponse == null)
            {
                Label lblNoResponse = new Label();
                lblNoResponse.Text = "<br/><br/><br/><br/><h3>" + GetLocalResourceObject("LblSessionExpired").ToString() + "</h3><br/>";
                attributeList.Controls.Add(lblNoResponse);
                return;
            }

            if (!Session["result"].ToString().EndsWith("success"))
            {
                Label lblDetail = new Label();
                lblDetail.Text += "<span id='title'>" + GetLocalResourceObject("LblSubStatusError").ToString() + "</span>" + ""/*samlResponse.SubStatusCodeStr */ + "<br/>";
                lblDetail.Text += "<span id='title'>" + GetLocalResourceObject("LblMessageError").ToString() + "</span>" + ""/*samlResponse.StatusMessage */ + "<br/>";
                attributeList.Controls.Add(lblDetail);
                return;
            }

            Label l = new Label();
            l.Text = "<br/></br><h2>" + GetLocalResourceObject("LblLoginSucceeded").ToString() + "</h2><div id='space'></div>";
            l.Text += "<h2>Proveedor de Identidad: " + "IdP de nodo español" + "</h2><div id='space'></div>"; 
            l.Text += "<h2>" + GetLocalResourceObject("LblRequestedData").ToString() + "</h2>";
            l.Text += "<table class='tabla' colpadding=4><tbody><tr class='filatit'><td>" + GetLocalResourceObject("LblAttributeName").ToString() + "</th><th>" + GetLocalResourceObject("LblAttributeValue").ToString() + "</th></tr>";

            for (int i = 0; i < xmlResponse.GetElementsByTagName("saml2:Attribute").Count; i++)
            {
                string FN = "";
                string data = "";

                for (int j = 0; j < xmlResponse.GetElementsByTagName("saml2:Attribute")[i].Attributes.Count; j++)
                {
                    if (xmlResponse.GetElementsByTagName("saml2:Attribute")[i].Attributes[j].Name == "FriendlyName")
                    {
                        FN = xmlResponse.GetElementsByTagName("saml2:Attribute")[i].Attributes[j].Value;
                        data = xmlResponse.GetElementsByTagName("saml2:Attribute")[i].InnerText;
                        break;
                    }
                }

                l.Text += "<tr class='filaresult'><td>" + FN + "</td><td>";

                l.Text += data + "<br/>";

                l.Text += "</td></tr>";
            }
            l.Text += "</Table>";
            attributeList.Controls.Add(l);
        }
    }
}