﻿using System;
using System.Web;
using System.Web.SessionState;
using System.Xml;
using Saml2Code;
using System.IO;

namespace eu.sp.Handlers
{
    public class ResponseLogOutHandler : IHttpHandler, IRequiresSessionState
    {
        public void ProcessRequest(HttpContext context)
        {
            string samlResponseField = ConfigurationSettingsHelper.GetCriticalConfigSetting("samlResponseLogoutField");
            string responseData = context.Request.Form[samlResponseField];
            string returnAction = null;

            byte[] reqDataB64 = Convert.FromBase64String(responseData);
            Stream stream = new MemoryStream(reqDataB64);

            //Convert the response to XML form
            XmlDocument xml = new XmlDocument();
            xml.PreserveWhitespace = true;
            xml.Load(stream);

            if (!Saml2Code.Utils.VerifyResponse(xml, true)) returnAction = Conf.get_url_fail_return();
            else returnAction = Conf.get_url_home();

            context.Response.Redirect(returnAction);
        }

        public bool IsReusable
        {
            get { return false; }
        }
    }
}
