﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.Runtime.Serialization;

namespace Saml2UpdateCertCONSOLE
{
    public enum CertificateUse
    {
        [EnumMember(Value = "Signing")]
        Signing,
        [EnumMember(Value = "Encryption")]
        Encryption
    }

    public class ClaveCertificate
    {
        private string _name;
        private string _publicKey;
        private bool _active;
        private CertificateUse _use;
        private string _downloadDate;

        public ClaveCertificate(string name, string publicKey, CertificateUse use, bool active, string downloadDate)
        {
            _name = name;
            _publicKey = publicKey;
            _use = use;
            _active = active;
            _downloadDate = downloadDate;
        }
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }
        [IgnoreDataMemberAttribute()]
        public string PublicKey
        {
            get { return _publicKey; }
            set { _publicKey = value; }
        }
        [JsonConverter(typeof(StringEnumConverter))]
        public CertificateUse Use
        {
            get { return _use; }
            set { _use = value; }
        }
        public bool Active
        {
            get { return _active; }
            set { _active = value; }
        }
        public string DownloadDate
        {
            get { return _downloadDate; }
            set { _downloadDate = value; }
        }
    }

}
