﻿using System;
using System.Configuration;
using System.IO;
using log4net;

namespace Saml2UpdateCertCONSOLE
{
    class Program
    {
        private static readonly ILog _log = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        static void Main(string[] args)
        {
            log4net.Config.XmlConfigurator.Configure();
            try
            {
                _log.Debug("Iniciando proceso...");
                var url = ConfigurationManager.AppSettings["UrlDescargaCertClave"];
                var certPath = ConfigurationManager.AppSettings["RutaCertificados"];
                Directory.CreateDirectory(certPath);
                _log.Info($"Inicio proceso -- URL descarga: {url}, Ruta ficheros: {certPath}");
                var worker = new UpdateCertWorker(url, certPath);
                worker.Log = _log;
                worker.Run();
            }
            catch (Exception ex)
            {
                _log.Error($"{ex.Message} -- {ex.StackTrace}");
            }
            finally
            {
                _log.Info($"Fin proceso");
            }

        }
    }
}
